4 USAGE='<fetch-options> <repository> <refspec>...'
7 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
8 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
22 while case "$#" in 0) break ;; esac
25 -a|--a|--ap|--app|--appe|--appen|--append)
28 --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
29 --upload-pa|--upload-pac|--upload-pack)
34 -f|--f|--fo|--for|--forc|--force)
37 -t|--t|--ta|--tag|--tags)
40 -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
43 -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
44 --update-he|--update-hea|--update-head|--update-head-|\
45 --update-head-o|--update-head-ok)
51 -k|--k|--ke|--kee|--keep)
66 test -f "$GIT_DIR/branches/origin" ||
67 test -f "$GIT_DIR/remotes/origin" ||
68 die "Where do you want to fetch from today?"
73 remote=$(get_remote_url "$@")
76 rsync_slurped_objects=
78 if test "" = "$append"
80 : >"$GIT_DIR/FETCH_HEAD"
83 append_fetch_head () {
90 t) not_for_merge_='not-for-merge' ;;
91 '') not_for_merge_= ;;
94 # remote-nick is the URL given on the command line (or a shorthand)
95 # remote-name is the $GIT_DIR relative refs/ path we computed
97 case "$remote_name_" in
101 note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
102 note_="branch '$note_' of " ;;
104 note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
105 note_="tag '$note_' of " ;;
107 note_="$remote_name of " ;;
109 remote_1_=$(expr "$remote_" : '\(.*\)\.git/*$') &&
111 note_="$note_$remote_"
113 # 2.6.11-tree tag would not be happy to be fed to resolve.
114 if git-cat-file commit "$head_" >/dev/null 2>&1
116 headc_=$(git-rev-parse --verify "$head_^0") || exit
117 echo "$headc_ $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
118 [ "$verbose" ] && echo >&2 "* committish: $head_"
119 [ "$verbose" ] && echo >&2 " $note_"
121 echo "$head_ not-for-merge $note_" >>"$GIT_DIR/FETCH_HEAD"
122 [ "$verbose" ] && echo >&2 "* non-commit: $head_"
123 [ "$verbose" ] && echo >&2 " $note_"
125 if test "$local_name_" != ""
127 # We are storing the head locally. Make sure that it is
128 # a fast forward (aka "reverse push").
129 fast_forward_local "$local_name_" "$head_" "$note_"
133 fast_forward_local () {
134 mkdir -p "$(dirname "$GIT_DIR/$1")"
137 # Tags need not be pointing at commits so there
138 # is no way to guarantee "fast-forward" anyway.
139 if test -f "$GIT_DIR/$1"
141 if now_=$(cat "$GIT_DIR/$1") && test "$now_" = "$2"
143 [ "$verbose" ] && echo >&2 "* $1: same as $3"
145 echo >&2 "* $1: updating with $3"
148 echo >&2 "* $1: storing $3"
150 git-update-ref "$1" "$2"
154 # $1 is the ref being updated.
155 # $2 is the new value for the ref.
156 local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
159 # Require fast-forward.
160 mb=$(git-merge-base "$local" "$2") &&
163 echo >&2 "* $1: same as $3"
166 echo >&2 "* $1: fast forward to $3"
167 echo >&2 " from $local to $2"
168 git-update-ref "$1" "$2" "$local"
174 echo >&2 "* $1: does not fast forward to $3;"
175 case ",$force,$single_force," in
177 echo >&2 " forcing update."
178 git-update-ref "$1" "$2" "$local"
181 echo >&2 " not updating."
186 echo >&2 "* $1: storing $3"
187 git-update-ref "$1" "$2"
193 case "$update_head_ok" in
195 orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
199 # If --tags (and later --heads or --all) is specified, then we are
200 # not talking about defaults stored in Pull: line of remotes or
201 # branches file, and just fetch those and refspecs explicitly given.
202 # Otherwise we do what we always did.
204 reflist=$(get_remote_refs_for_fetch "$@")
208 git-ls-remote $upload_pack --tags "$remote" |
214 if git-check-ref-format "$name"
216 echo ".${name}:${name}"
218 echo >&2 "warning: tag ${name} ignored"
223 # remote URL plus explicit refspecs; we need to merge them.
224 reflist="$reflist$LF$taglist"
226 # No explicit refspecs; fetch tags only.
239 # These are relative path from $GIT_DIR, typically starting at refs/
241 if expr "$ref" : '\.' >/dev/null
244 ref=$(expr "$ref" : '\.\(.*\)')
248 if expr "$ref" : '\+' >/dev/null
251 ref=$(expr "$ref" : '\+\(.*\)')
255 remote_name=$(expr "$ref" : '\([^:]*\):')
256 local_name=$(expr "$ref" : '[^:]*:\(.*\)')
258 rref="$rref$LF$remote_name"
260 # There are transports that can fetch only one head at a time...
262 http://* | https://*)
263 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
266 remote_name_quoted=$(perl -e '
268 $u =~ s{([^-a-zA-Z0-9/.])}{sprintf"%%%02x",ord($1)}eg;
271 head=$(curl -nsfL $curl_extra_args "$remote/$remote_name_quoted") &&
272 expr "$head" : "$_x40\$" >/dev/null ||
273 die "Failed to fetch $remote_name from $remote"
274 echo >&2 Fetching "$remote_name from $remote" using http
275 git-http-fetch -v -a "$head" "$remote/" || exit
278 TMP_HEAD="$GIT_DIR/TMP_HEAD"
279 rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
280 head=$(git-rev-parse --verify TMP_HEAD)
282 test "$rsync_slurped_objects" || {
283 rsync -av --ignore-existing --exclude info \
284 "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
286 # Look at objects/info/alternates for rsync -- http will
287 # support it natively and git native ones will do it on
288 # the remote end. Not having that file is not a crime.
289 rsync -q "$remote/objects/info/alternates" \
290 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
291 rm -f "$GIT_DIR/TMP_ALT"
292 if test -f "$GIT_DIR/TMP_ALT"
294 resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
297 case "$alt" in 'bad alternate: '*) die "$alt";; esac
298 echo >&2 "Getting alternate: $alt"
299 rsync -av --ignore-existing --exclude info \
300 "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
302 rm -f "$GIT_DIR/TMP_ALT"
304 rsync_slurped_objects=t
308 # We will do git native transport with just one call later.
312 append_fetch_head "$head" "$remote" \
313 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
318 http://* | https://* | rsync://* )
319 ;; # we are already done.
321 ( : subshell because we muck with IFS
324 git-fetch-pack $exec $keep --thin "$remote" $rref || echo failed "$remote"
326 while read sha1 remote_name
330 echo >&2 "Fetch failure: $remote"
358 local_name=$(expr "$found" : '[^:]*:\(.*\)')
359 append_fetch_head "$sha1" "$remote" \
360 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
367 fetch_main "$reflist"
369 # automated tag following
370 case "$no_tags$tags" in
374 # effective only when we are following remote branch
375 # using local tracking branch.
377 git-ls-remote $upload_pack --tags "$remote" |
378 sed -ne 's|^\([0-9a-f]*\)[ ]\(refs/tags/.*\)^{}$|\1 \2|p' |
381 test -f "$GIT_DIR/$name" && continue
382 git-check-ref-format "$name" || {
383 echo >&2 "warning: tag ${name} ignored"
386 git-cat-file -t "$sha1" >/dev/null 2>&1 || continue
387 echo >&2 "Auto-following $name"
388 echo ".${name}:${name}"
394 fetch_main "$taglist" ;;
398 # If the original head was empty (i.e. no "master" yet), or
399 # if we were told not to worry, we do not have to check.
400 case ",$update_head_ok,$orig_head," in
404 curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
405 if test "$curr_head" != "$orig_head"
407 git-update-ref HEAD "$orig_head"
408 die "Cannot fetch into the current branch."